#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define int long long
#define F first
#define S second
using namespace std;
using namespace __gnu_pbds;

template<class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

string ssum(string &a, string &b) {
    if (a.size() < b.size()) {
        swap(a, b);
    }
    string sum(a.size(), '0');
    for (int i = 0; i < a.size(); ++i) {
        if (i <= b.size()) {
            sum[i] = max(a[i], b[i]);
        } else {
            sum[i] = a[i];
        }
    }
    return sum;
}

void solve() {
    string a, b;
    cin >> a >> b;
    reverse(a.begin(), a.end());
    reverse(b.begin(), b.end());
    string sum = ssum(a, b), prod;
    for (int i = 0; i < b.size(); ++i) {
        string s (i, '0');
        for (char j : a) {
            s.push_back(min(j, b[i]));
        }
        prod = ssum(s, prod);
    }
    while (prod.back() == '0') {
        prod.pop_back();
    }
    std::reverse(sum.begin(), sum.end());
    std::reverse(prod.begin(), prod.end());
    cout << sum << " " << prod;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}