#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define int long long
#define F first
#define S second
using namespace std;
using namespace __gnu_pbds;

template<class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

void solve() {
    int a, b;
    cin >> a >> b;
    int g = gcd(a, b);
    a /= g;
    b /= g;
    pair<int, int> l{0, 1}, r{1, 0};
    string ans = "R";
    int cnt = 0;
    while (cnt < 1000000) {
        ++cnt;
        int na = l.F + r.F, nb = l.S + r.S;
        g = gcd(na, nb);
        na /= g;
        nb /= g;
        if (na == a && nb == b) {
            cout << ans << "\n";
            return;
        }
        if (na * b >= a * nb) {
            r = {na, nb};
            ans.push_back('L');
        } else {
            l = {na, nb};
            ans.push_back('R');
        }
    }
    cout << "no\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}