#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define int long long
#define F first
#define S second
using namespace std;
using namespace __gnu_pbds;

template<class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

void solve() {
    int n, m, k;
    cin >> n >> m >> k;
    vector<vector<int>> g(n);
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g[u].emplace_back(v);
        g[v].emplace_back(u);
    }
    vector<int> h(n);
    for (int i = 0; i < k; ++i) {
        int p;
        cin >> p;
        --p;
        cin >> h[p];
    }
    set<pair<int, int>, greater<>> s;
    vector<int> d(n, -1);
    for (int i = 0; i < n; ++i) {
        if (h[i] != 0) {
            s.insert({h[i], i});
            d[i] = h[i];
        }
    }
    while (!s.empty()) {
        auto [x, v] = *s.begin();
        s.erase(s.begin());
        for (auto u : g[v]) {
            if (d[u] < d[v] - 1 && d[v] - 1 >= 0) {
                s.erase({d[u], u});
                d[u] = d[v] - 1;
                s.insert({d[u], u});
            }
        }
    }
    vector<int> ans;
    for (int i = 0; i < n; ++i) {
        if (d[i] >= 0) {
            ans.push_back(i + 1);
        }
    }
    cout << ans.size() << "\n";
    for (auto i : ans) {
        cout << i << " ";
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}